<?php

namespace AppBundle\Controller\Admin;

use AppBundle\Entity\Property;
use AppBundle\Entity\PropertyMetaOption;
use AppBundle\Entity\SystemMeta;
use AppBundle\Entity\Resource;
use AppBundle\Entity\City;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;

abstract class BaseController extends Controller {
        
    protected function SaveEntity($entity) {
        $em = $this->getDoctrine()->getManager();
        $em->persist($entity);
        $em->flush();
    }
    
    protected function RemoveEntity($entity) {
        $em = $this->getDoctrine()->getManager();
        $em->remove($entity);
        $em->flush();
    }
    
    protected function UpdateEntity() {
        $em = $this->getDoctrine()->getManager();
        $em->flush();
    }
    
    protected function getProperties() {              
        return $this->getDoctrine()->getRepository(Property::class);
    } 
    
    protected function getResources() {              
        return $this->getDoctrine()->getRepository(Resource::class);
    }
    
    protected function getSystemMetas() {              
        return $this->getDoctrine()->getRepository(SystemMeta::class);
    }
    
    protected function getSystemMeta($key) {              
        return $this->getSystemMetas()->get($key);
    }
    
    protected function getPropertyMetaOptions() {              
        return $this->getDoctrine()->getRepository(PropertyMetaOption::class);
    }  
    
    protected function getCities() {              
        return $this->getDoctrine()->getRepository(City::class);
    } 
    
}
