<?php

namespace AppBundle\Controller\Admin;

use AppBundle\Entity\City;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Symfony\Component\HttpFoundation\Request;

/**
 * Admin\City controller.
 *
 * @Route("/admin/city")
 */
class CityController extends BaseController {

    /**
     * @Route("/", name="admin_city_index")
     * @Method("GET")
     * @Template()
     */
    public function indexAction() {
        $entities = $this->getCities()->findAll();

        return array(
            'entities' => $entities,
        );
    }

    /**
     * @Route("/", name="admin_city_save")
     * @Method("POST")
     * @Template("@App/Admin/City/index.html.twig")
     */
    public function saveAction(Request $request) {

        if ($request->request->has('city_action')) {

            foreach ($request->request->get('city_action') as $key => $value) {                
                $this->$value($request, $key);
            }
        }

        $entities = $this->getCities()->findAll();

        return array(
            'entities' => $entities,
        );
    }
    
    private function create(Request $request, $key) {
        $city = new City();
        $city->setName($request->request->get('city_name')[$key]);
        $city->setZipCode($request->request->get('city_zipcode')[$key]);
        $this->SaveEntity($city);
    }
    
    private function update(Request $request, $key) {
        $city = $this->getCities()->find($key);
        $city->setName($request->request->get('city_name')[$key]);
        $city->setZipCode($request->request->get('city_zipcode')[$key]);
        $this->SaveEntity($city);
    }
    
    private function delete(Request $request, $key) {
        $city = $this->getCities()->find($key);
        $this->RemoveEntity($city);
    }

}
