<?php

namespace AppBundle\Controller\Admin;

use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Symfony\Component\HttpFoundation\Request;

/**
 * Admin\Option controller.
 *
 * @Route("/admin/option")
 */
class OptionController extends BaseController {

    /**
     * @Route("/", name="admin_option_index")
     * @Method("GET")
     * @Template()
     */
    public function indexAction() {
        $entities = $this->getPropertyMetaOptions()->findAll();

        return array(
            'entities' => $entities,
        );
    }

    /**
     * @Route("/", name="admin_option_save")
     * @Method("POST")
     * @Template("@App/Admin/Option/index.html.twig")
     */
    public function saveAction(Request $request) {

        if ($request->request->has('option')) {

            foreach ($request->request->get('option') as $key => $value) {
                $option = $this->getPropertyMetaOptions()->findOneByKey($key);
                $option->setOption($value);
                $this->SaveEntity($option);
            }
        }

        $entities = $this->getPropertyMetaOptions()->findAll();

        return array(
            'entities' => $entities,
        );
    }

}
