<?php

namespace AppBundle\Controller\Admin;

use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Symfony\Component\HttpFoundation\Request;

/**
 * Admin\Resource controller.
 *
 * @Route("/admin/resource")
 */
class ResourceController extends BaseController {

    /**
     * @Route("/", name="admin_resource_index")
     * @Method("GET")
     * @Template()
     */
    public function indexAction() {
        $entities = $this->getResources()->findAll();

        return array(
            'entities' => $entities,
        );
    }

    /**
     * @Route("/", name="admin_resource_save")
     * @Method("POST")
     * @Template("@App/Admin/Resource/index.html.twig")
     */
    public function saveAction(Request $request) {

        if ($request->request->has('resource')) {

            foreach ($request->request->get('resource') as $key => $value) {
                $rsx = $this->getResources()->findOneByKey($key);
                $rsx->setValue($value);
                $this->SaveEntity($rsx);
            }
        }

        $entities = $this->getResources()->findAll();

        return array(
            'entities' => $entities,
        );
    }

}
