<?php

namespace AppBundle\Controller\Admin;

use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Symfony\Component\HttpFoundation\Request;

/**
 * Admin\System controller.
 *
 * @Route("/admin/system")
 */
class SystemController extends BaseController {

    /**
     * @Route("/", name="admin_system_index")
     * @Method("GET")
     * @Template()
     */
    public function indexAction() {
        $entities = $this->getSystemMetas()->findAll();

        return array(
            'entities' => $entities,
        );
    }

    /**
     * @Route("/", name="admin_system_save")
     * @Method("POST")
     * @Template("@App/Admin/System/index.html.twig")
     */
    public function saveAction(Request $request) {

        if ($request->request->has('meta')) {

            foreach ($request->request->get('meta') as $key => $value) {
                $meta = $this->getSystemMetas()->findOneByKey($key);
                $meta->setValue($value);
                $this->SaveEntity($meta);
            }
        }

        $entities = $this->getSystemMetas()->findAll();

        return array(
            'entities' => $entities,
        );
    }

}
