<?php

namespace AppBundle\Controller\Web;

use AppBundle\Entity\Contact;
use DateTime;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Swift_Message;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;

class ContactController extends Controller
{
    /**
     * @Route("/contacto", name="web_contact_index")
     * @Template
     */
    public function indexAction()
    {
        // replace this example code with whatever you need
        return array('success' => true);
    }    
    
    /**
     * @Route("/submit/", name="web_contact_submit")
     * @Method("POST")
     * @Template()
     */
    public function submitAction(Request $request)
    {
        $contact = new Contact();
        $contact->setName($request->get("name"));
        $contact->setEmail($request->get("email"));
        $contact->setSubject($request->get("subject"));
        $contact->setPhone($request->get("phone"));
        $contact->setMessage($request->get("message"));        
        $contact->setDate(new DateTime());
        
        /* Se envía el mail */
        $message = Swift_Message::newInstance()
                ->setSubject('Contacto en la Web')
                ->setFrom('noreply@dpinmobiliaria.com')
                ->setTo('f.leoni.verdes@gmail.com')
                ->setBody(
                $this->renderView(
                        'AppBundle:Web:Contact/template.html.twig', array('contact' => $contact)
                ), 'text/html');
                
        $this->get('mailer')->send($message);
        
        $this->SaveEntity($contact);
                
        return new JsonResponse(array('success' => true));
    }
    
    protected function SaveEntity($entity) {
        $em = $this->getDoctrine()->getManager();
        $em->persist($entity);
        $em->flush();
    }
       
}
