<?php

namespace AppBundle\Controller\Web;

use AppBundle\Filter\PropertyFilter;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;

class SearchController extends Controller
{    
    protected function getCities() {              
        return $this->getDoctrine()->getRepository('AppBundle:City');
    }
    
    protected function getProperties() {              
        return $this->getDoctrine()->getRepository('AppBundle:Property');
    }
    
    protected function getPropertyMetas() {              
        return $this->getDoctrine()->getRepository('AppBundle:PropertyMeta');
    }
        
    /**
     * @Template
     */
    public function homeAction()
    {        
        $cities = $this->getCities()->findAllWithProperties();
        
        $tiposDeOperacion = $this->getPropertyMetas()->findAllValuesWithPropertiesForKey('Tipo de operación');
        
        $tiposDePropiedad = $this->getPropertyMetas()->findAllValuesWithPropertiesForKey('Tipo de propiedad');
        
        $ambientes = $this->getPropertyMetas()->findAllValuesWithPropertiesForKey('Ambientes', true);
        
        $baños = $this->getPropertyMetas()->findAllValuesWithPropertiesForKey('Baños', true);
        
        $precioArs = $this->getPropertyMetas()->findAllValuesWithPropertiesForKey('Precio $', true);
        
        $precioUsd = $this->getPropertyMetas()->findAllValuesWithPropertiesForKey('Precio u$s', true);
               
        return array('cities' => $cities, 'tiposDeOperacion' => $tiposDeOperacion, 'tiposDePropiedad' => $tiposDePropiedad,
            'ambientes' => $ambientes, 'baños' => $baños, 'precioArs' => $precioArs, 'precioUsd' => $precioUsd);
    }  
    
    /**
     * @Template
     */
    public function sidebarAction($filter = null)
    {
        $cities = $this->getCities()->findAllWithProperties();
        
        $tiposDeOperacion = $this->getPropertyMetas()->findAllValuesWithPropertiesForKey('Tipo de operación');
        
        $tiposDePropiedad = $this->getPropertyMetas()->findAllValuesWithPropertiesForKey('Tipo de propiedad');
        
        $ambientes = $this->getPropertyMetas()->findAllValuesWithPropertiesForKey('Ambientes', true);
        
        $baños = $this->getPropertyMetas()->findAllValuesWithPropertiesForKey('Baños', true);
        
        $precioArs = $this->getPropertyMetas()->findAllValuesWithPropertiesForKey('Precio $', true);
        
        $precioUsd = $this->getPropertyMetas()->findAllValuesWithPropertiesForKey('Precio u$s', true);
        
        $amenities = $this->getPropertyMetas()->findAllMultipleValuesWithPropertiesForKey('Amenities');
        
        $caracteristicas = $this->getPropertyMetas()->findAllMultipleValuesWithPropertiesForKey('Características');
                       
        if ($filter == null)
            $filter = new PropertyFilter();
        
        return array('cities' => $cities, 'tiposDeOperacion' => $tiposDeOperacion, 'tiposDePropiedad' => $tiposDePropiedad,
            'ambientes' => $ambientes, 'baños' => $baños, 'precioArs' => $precioArs, 'precioUsd' => $precioUsd,
            'amenities' => $amenities, 'caracteristicas' => $caracteristicas, 'filter' => $filter);
    }       
    
    /**
     * @Route("/propiedades/buscar", name="web_search_results")
     * @Template
     */
    public function resultsAction(Request $request)
    {
        $q = $request->get('q');
        
        $properties = $this->getProperties()->findAllByQuery($q);
        
        return array('value' => $q, 'properties' => $properties);
    }
    
    /**
     * @Route("/propiedades/filtro", name="web_search_filter")
     * @Template
     */
    public function filterAction(Request $request)
    {        
        $filter = new PropertyFilter();
        $filter->LoadFromRequest($request);
        
        $properties = $this->getProperties()->findAllByFilter($filter);
        
        return array('properties' => $properties, 'filter' => $filter);
    }
}
