<?php

namespace AppBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass="AppBundle\Repository\PropertyMetaRepository")
 * @ORM\Table(name="app_property_meta")
 */
class PropertyMeta
{              
    /**
     * @ORM\Id
     * @ORM\Column(type="string", length=255, name="`key`")
     */
    protected $key;

    /**
     * @ORM\Column(type="text")
     */
    protected $value;
    
    /**
     * @ORM\Id
     * @ORM\ManyToOne(targetEntity="AppBundle\Entity\PropertyMetaOption", inversedBy="meta")
     * @ORM\JoinColumn(name="`key`", referencedColumnName="key")
     */
    protected $option;
    
    /**
     * @ORM\Id
     * @ORM\ManyToOne(targetEntity="AppBundle\Entity\Property", inversedBy="meta")
     * @ORM\JoinColumn(name="property_id", referencedColumnName="id")
     */
    protected $property;

    // ↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓ Codigo autogenerado ↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓
    
    /**
     * Set key
     *
     * @param string $key
     * @return DynamicVariable
     */
    public function setKey($key)
    {
        $this->key = $key;

        return $this;
    }

    /**
     * Get key
     *
     * @return string 
     */
    public function getKey()
    {
        return $this->key;
    }

    /**
     * Set value
     *
     * @param string $value
     * @return DynamicVariable
     */
    public function setValue($value)
    {
        $this->value = $value;

        return $this;
    }

    /**
     * Get value
     *
     * @return string 
     */
    public function getValue()
    {
        return $this->value;
    }
    
    /**
     * Set option
     *
     * @param \AppBundle\Entity\PropertyMetaOption $option
     * @return PropertyMeta
     */
    public function setOption(\AppBundle\Entity\PropertyMetaOption $option)
    {
        $this->option = $option;

        return $this;
    }

    /**
     * Get option
     *
     * @return \AppBundle\Entity\PropertyMetaOption 
     */
    public function getOption()
    {
        return $this->option;
    }
    
    
    /**
     * Set property
     *
     * @param \AppBundle\Entity\Property $property
     * @return PropertyMeta
     */
    public function setProperty(\AppBundle\Entity\Property $property)
    {
        $this->property = $property;

        return $this;
    }

    /**
     * Get property
     *
     * @return \AppBundle\Entity\Property 
     */
    public function getProperty()
    {
        return $this->property;
    }
    
    // ↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓ Codigo extra ↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓
    
    /**
     * Get choices
     *
     * @return array 
     */
    public function getChoices()
    {        
        if ($this->getOption()->getType() != 'multichoice') {
            return null;
        }
        
        return explode('|', $this->value);
    }
    
    
}
