<?php

namespace AppBundle\Filter;
/**
 * Description of PropertyFilter
 *
 * @author Usuario
 */
class PropertyFilter {
   
    protected function GetValue($value) {
        if ($value == "") {
            return null;
        }
        
        return $value;
    }
    
    protected $city;

    protected $operationType;
    
    protected $propertyType;
    
    protected $bedrooms;
    
    protected $bathrooms;
    
    protected $maxPriceArs;
    
    protected $minPriceArs;
    
    protected $maxPriceUsd;
    
    protected $minPriceUsd;
    
    protected $characteristics;
    
    protected $amenities;

    public function __construct($city = null, $operationType = null, $propertyType = null, $bedrooms = null, 
            $bathrooms = null, $maxPriceArs = null, $minPriceArs = null, $maxPriceUsd = null, $minPriceUsd = null,
            $characteristics = [], $amenities = []) {
        $this->city = $city;
        $this->operationType = $operationType;
        $this->propertyType = $propertyType;
        $this->bedrooms = $bedrooms;
        $this->bathrooms = $bathrooms;
        $this->maxPriceArs = $maxPriceArs;
        $this->minPriceArs = $minPriceArs;
        $this->maxPriceUsd = $maxPriceUsd;
        $this->minPriceUsd = $minPriceUsd;   
        $this->characteristics = $characteristics;
        $this->amenities = $amenities;
    }
    
    public function getCity() {
        return $this->GetValue($this->city);
    }
    
    public function getOperationType() {
        return $this->GetValue($this->operationType);
    }
    
    public function getPropertyType() {
        return $this->GetValue($this->propertyType);
    }
    
    public function getBedrooms() {
        return $this->GetValue($this->bedrooms);
    }
    
    public function getBathrooms() {
        return $this->GetValue($this->bathrooms);
    }
    
    public function getMaxPriceArs() {
        return $this->GetValue($this->maxPriceArs);
    }
    
    public function getMinPriceArs() {
        return $this->GetValue($this->minPriceArs);
    }
    
    public function getMaxPriceUsd() {
        return $this->GetValue($this->maxPriceUsd);
    }
    
    public function getMinPriceUsd() {
        return $this->GetValue($this->minPriceUsd);
    }
    
    function getCharacteristics() {
        return $this->characteristics;
    }

    function getAmenities() {
        return $this->amenities;
    }
        
    public function LoadFromRequest(\Symfony\Component\HttpFoundation\Request $request) {        
        $this->city = $request->get("location", $this->city);
        $this->operationType = $request->get("operation-type", $this->operationType);
        $this->propertyType = $request->get("property-type", $this->propertyType);
        $this->bedrooms = $request->get("bedrooms", $this->bedrooms);
        $this->bathrooms = $request->get("bathrooms", $this->bathrooms);
        
        if ($request->get('max_price_ars') != $request->get('price_ars_max')) {
            $this->maxPriceArs = $request->get("max_price_ars", $this->maxPriceArs);
        }
        
        if ($request->get('min_price_ars') != '0') {
            $this->minPriceArs = $request->get("min_price_ars", $this->minPriceArs);
        }
        
        if ($request->get('max_price_usd') != $request->get('price_usd_max')) {
            $this->maxPriceUsd = $request->get("max_price_usd", $this->maxPriceUsd);
        }
        
        if ($request->get('min_price_usd') != '0') {
            $this->minPriceUsd = $request->get("min_price_usd", $this->minPriceUsd);
        }
        
        $this->characteristics = $request->get("caracteristicas", $this->characteristics);
        
        $this->amenities = $request->get("amenities", $this->amenities);
    }
    
}
