<?php

namespace AppBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

class PropertyType extends AbstractType {

    /**
     * @param FormBuilderInterface $builder
     * @param array $options
     */
    public function buildForm(FormBuilderInterface $builder, array $options) {
        $builder
                ->add('title', 'text', array('label' => 'Título'))
                ->add('briefDescription', 'textarea', array('label' => 'Descripción breve'))
                ->add('description', 'hidden', array('label' => 'Descripción'))
                ->add('address', 'text', array('label' => 'Ubicación'))
                ->add('published', 'checkbox', array('required' => false, 'label' => 'Publicada'))
                ->add('featured', 'checkbox', array('required' => false, 'label' => 'Destacada'))
                ->add('city', 'entity' ,array('class' => 'AppBundle:City', 'label' => 'Ciudad'))
        ;
    }

    /**
     * @param OptionsResolverInterface $resolver
     */
    public function setDefaultOptions(OptionsResolverInterface $resolver) {
        $resolver->setDefaults(array(
            'data_class' => 'AppBundle\Entity\Property'
        ));
    }

    /**
     * @return string
     */
    public function getName() {
        return 'property';
    }

}
