<?php

namespace AppBundle\Repository;

use Doctrine\ORM\EntityRepository;

class PropertyMetaRepository extends EntityRepository {

    public function findAllValuesWithPropertiesForKey($key, $numeric = false) {
        return $this->createQueryBuilder('pm')
                        ->select('pm.value')
                        ->innerJoin('pm.property', 'p')
                        ->where('p.published = 1')
                        ->andWhere('pm.key = :key')
                        ->setParameter('key', $key)
                        ->orderBy($numeric ? 'ABS(pm.value)' : 'pm.value', 'ASC')
                        ->distinct()
                        ->getQuery()
                        ->getResult();
    }

    public function findAllMultipleValuesWithPropertiesForKey($key) {
        $result = $this->createQueryBuilder('pm')
                ->select('pm.value')
                ->innerJoin('pm.property', 'p')
                ->where('p.published = 1')
                ->andWhere('pm.key = :key')
                ->setParameter('key', $key)
                ->getQuery()
                ->getResult();

        $metas = [];

        foreach ($result as $key => $meta) {
            $values = explode("|", $meta['value']);

            foreach ($values as $value) {
                if (!in_array($value, $metas)) {
                    $metas[] = $value;
                }
            }
        }
        
        sort($metas);
        
        return $metas;
    }

}
