<?php

namespace AppBundle\Twig;

class SystemMetaExtension extends \Twig_Extension implements \Twig_Extension_GlobalsInterface
{
    private $em;
 
    public function __construct(\Doctrine\ORM\EntityManager $em) {
        $this->em = $em;
    }
    
    public function getName()
    {
        return 'system_meta_extension';
    }
    
    public function getGlobals()
    {
        $SystemMeta = $this->em->getRepository('AppBundle:SystemMeta');
        
        $data = array();
        
        foreach ($SystemMeta->findAll() as $sm){
            $data[$sm->getKey()] = $sm->getValue();
        }
        
        $Resources = $this->em->getRepository('AppBundle:Resource');
        
        foreach ($Resources->findAll() as $sm){
            $data['r_' . $sm->getKey()] = $sm->getValue();
        }
        
        return $data;
    }
}