$(function(){
   InitializeAdmin();
   
   $('body').on('click', '[data-save]', function(){
      
        $this = $('[name=' + $(this).data("save")+ ']');
        $($this).animate({ "opacity" : "0.5" }, function () {
            SubmitForm($this);
        });
        return false;
       
   });
   
   $('body').on('click', '[data-delete]', function(){
       
       $this = $(this);
       $form = $(this).siblings("form");
       
       bootbox.confirm("¿Realmente desea borrar este elemento?", function(result) {
           
           if (result) {                
                $fadeOut = $('[name=' + $($this).data("delete")+ ']');
                $($fadeOut).animate({ "opacity" : "0.5" }, function () {
                    SubmitForm($form);
                });
           }         
           
       });
       return false;
       
   });
   
   $('body').on('change', '[data-selectfor]', function(){
      
        $input = $('#' + $(this).data("selectfor"));
        $($input).val($(this).val().join('|'));
       
   });
   
   $('body').on('change', '.meta-option [type=checkbox]', ToggleMetaStatus);
   
   $('body').on('click','form[name=property] .image-container a.img-delete', function(e){
        e.preventDefault();
        
        $this = $(this);
        
        bootbox.confirm('¿Realmente desea eliminar esta imagen?', function(result){
           
           if (result) {
                var $div = $($this).parent().parent();        
                $($div).hide();
                $('.image-container').append($div);
                if ($($this).siblings("input[type=hidden]").val() === "add") {
                    $($div).remove();
                } else {
                    $($this).siblings("input[type=hidden]").val("remove");
                }
                
           }
           
        });
    });
    
});

function InitializeAdmin() {    
    InitializeBoostrapEditors();
    ToSelect2();
}

function InitializeBoostrapEditors() {   
    $('.wysiwyg:not(.active)').each(function(){      
        var target = $(this).data('for');      
        $(this).addClass('active').html($(target).val()).wysiwyg().on('keyup blur', function() {
              $(target).val($(this).cleanHtml());
        }); 
    });   
}

function ToSelect2() {
    $('.to-select2').each(function() {
        $(this).select2();
    });
}

function SubmitForm($form) {
    $.ajax({
        type: $($form).prop("method"),
        url: $($form).prop("action"),
        data: $($form).serialize(),
        success: function (msg) {
            $(".content.container").empty().append(msg);
        },
        error: function () { alert("Error"); },
        complete: function () { 
             InitializeAdmin();
        }
    });
}

function InitializePropertyMeta() {
    $('.meta-option [type=checkbox]').each(ToggleMetaStatus);
}

function ToggleMetaStatus() {
    if ($(this).is(':checked')) {
        $(this).parent().siblings('select,input').each(function(){
            $(this).prop('disabled',false);
        });
    } else {
        $(this).parent().siblings('select,input').each(function(){
            $(this).prop('disabled','disabled');
        });
    }
}

function InitializePropertyImgUpload() {
    $('#fileupload').fileupload({
        dataType: 'json',
        done: function (e, data) {
            console.log(data);
            $.each(data.result.files, function (index, file) {
                var $innerDiv = $('<div>')
                    .append('<input type="hidden" name="img[' + file.name + ']" value="add" />')
                    .append('<img src="/files/' + file.name + '" />')
                    .append('<a href="#move" class="img-move" title="Mover"><i class="glyphicon glyphicon-move"></i></a><a href="/files/' + file.name + '" class="img-zoom" title="Zoom" data-toggle="lightbox" data-title="Imagen"><i class="glyphicon glyphicon-zoom-in"></i></a><a href="#delete" class="img-delete" title="Borrar"><i class="glyphicon glyphicon-remove"></i></a>');
                
                var $div = $('<div class="col-md-4 col-lg-3" />')
                    .append($innerDiv);
                    
                $(".image-container").append($div);
            });
        }
    });
    
    $('.image-container').sortable({ handle: 'a.img-move' });
}